diff -urN ../sys/alpha/conf/ALTQ ./alpha/conf/ALTQ
--- ../sys/alpha/conf/ALTQ	Thu Jan  1 09:00:00 1970
+++ ./alpha/conf/ALTQ	Tue Oct  2 22:21:10 2001
@@ -0,0 +1,211 @@
+#
+# GENERIC -- Generic kernel configuration file for FreeBSD/alpha
+#
+# For more information on this file, please read the handbook section on
+# Kernel Configuration Files:
+#
+#    http://www.FreeBSD.org/handbook/kernelconfig-config.html
+#
+# The handbook is also available locally in /usr/share/doc/handbook
+# if you've installed the doc distribution, otherwise always see the
+# FreeBSD World Wide Web server (http://www.FreeBSD.org/) for the
+# latest information.
+#
+# An exhaustive list of options and more detailed explanations of the
+# device lines is also present in the ../../i386/conf/LINT configuration file. 
+# If you are in doubt as to the purpose or necessity of a line, check first 
+# in LINT. Please note that this is the i386 LINT, but it still contains
+# valuable info for alpha too
+#
+# For hardware specific information check HARDWARE.TXT
+#
+# $FreeBSD: src/sys/alpha/conf/GENERIC,v 1.71.2.15 2001/07/30 17:31:41 wpaul Exp $
+
+machine		alpha
+cpu		EV4
+cpu		EV5
+ident		ALTQ
+maxusers	32
+
+#makeoptions	DEBUG=-g		#Build kernel with gdb(1) debug symbols
+
+# Platforms supported
+options		API_UP1000		# UP1000 (Nautilus)
+options 	DEC_AXPPCI_33		# UDB, Multia, AXPpci33, Noname
+options 	DEC_EB164		# EB164, PC164, PC164LX, PC164SX
+options 	DEC_EB64PLUS		# EB64+, Aspen Alpine, etc
+options 	DEC_2100_A50		# AlphaStation 200, 250, 255, 400
+options 	DEC_2100_A500		# AlphaServer 2000, 2100, 2100A
+options 	DEC_KN20AA		# AlphaStation 500, 600
+options 	DEC_ST550		# Personal Workstation 433, 500, 600
+options 	DEC_ST6600		# xp1000, dp264, ds20, ds10, family
+options 	DEC_3000_300		# DEC3000/300* Pelic* family
+options 	DEC_3000_500		# DEC3000/[4-9]00 Flamingo/Sandpiper family
+options 	DEC_1000A		# AlphaServer 1000, 1000A, 800
+options 	DEC_KN8AE		# AlphaServer 8200/8400 (Turbolaser)
+options 	DEC_KN300		# AlphaServer 4100 (Rawhide), 1200 (Tincup)
+
+options 	INET			#InterNETworking
+options 	INET6			#IPv6 communications protocols
+options 	FFS			#Berkeley Fast Filesystem
+options 	FFS_ROOT		#FFS usable as root device [keep this!]
+options 	SOFTUPDATES		#Enable FFS soft updates support
+options 	MFS			#Memory Filesystem
+options 	MD_ROOT			#MD is a potential root device
+options 	NFS			#Network Filesystem
+options 	NFS_ROOT		#NFS usable as root device
+options 	MSDOSFS			#MSDOS Filesystem
+options 	CD9660			#ISO 9660 Filesystem
+options 	CD9660_ROOT		#CD-ROM usable as root device
+options 	PROCFS			#Process filesystem
+options 	COMPAT_43		#Compatible with BSD 4.3 [KEEP THIS!]
+options 	SCSI_DELAY=15000	#Delay (in ms) before probing SCSI 
+options 	UCONSOLE		#Allow users to grab the console
+options 	KTRACE			#ktrace(1) syscall trace support
+options 	SYSVSHM			#SYSV-style shared memory
+options 	SYSVMSG			#SYSV-style message queues
+options 	SYSVSEM			#SYSV-style semaphores
+options		P1003_1B		#Posix P1003_1B real-time extentions
+options 	_KPOSIX_PRIORITY_SCHEDULING
+options		ICMP_BANDLIM		#Rate limit bad replies
+
+# Standard busses
+device		isa
+device		pci
+
+# Floppy drives
+device		fdc0	at isa? port IO_FD1 irq 6 drq 2
+device		fd0	at fdc0 drive 0
+
+# ATA and ATAPI devices
+device		ata
+device		atadisk		# ATA disk drives
+device		atapicd		# ATAPI CDROM drives
+device		atapifd		# ATAPI floppy drives
+device		atapist		# ATAPI tape drives
+
+# SCSI Controllers
+device		ahc		# AHA2940 and onboard AIC7xxx devices
+#device		esp		# 53C94 & friends, not CAM-ified
+device		isp		# Qlogic family
+device		ncr		# NCR/Symbios Logic
+device		sym		# NCR/Symbios Logic (newer chipsets)
+
+# SCSI peripherals
+device		scbus		# SCSI bus (required)
+device		da		# Direct Access (disks)
+device		sa		# Sequential Access (tape etc)
+device		cd		# CD
+device		pass		# Passthrough device (direct SCSI access)
+
+# RAID controllers
+device		amr		# AMI MegaRAID
+device		mlx		# Mylex DAC960 family
+
+# atkbdc0 controls both the keyboard and the PS/2 mouse
+device		atkbdc0	at isa? port IO_KBD
+device		atkbd0	at atkbdc? irq 1
+device		psm0	at atkbdc? irq 12
+
+device		vga0	at isa?
+
+# splash screen/screen saver
+pseudo-device	splash
+
+# syscons is the default console driver, resembling an SCO console
+device		sc0	at isa?
+
+# real time clock
+device		mcclock0 at isa? port 0x70
+
+# Serial (COM) ports
+device		sio0	at isa? port IO_COM1 irq 4
+device		sio1	at isa? port IO_COM2 irq 3 flags 0x50
+
+# Parallel port
+device          ppc0    at isa? irq 7
+device          ppbus           # Parallel port bus (required)
+device          lpt             # Printer
+device          plip            # TCP/IP over parallel
+device          ppi             # Parallel port interface device
+#device         vpo             # Requires scbus and da
+ 
+# PCI Ethernet NICs.
+device		de		# DEC/Intel DC21x4x (``Tulip'')
+device		txp		# 3Com 3cR990 (``Typhoon'')
+device		le		# Lance
+
+# PCI Ethernet NICs that use the common MII bus controller code.
+device		miibus		# MII bus support
+device		dc		# DEC/Intel 21143 and workalikes
+device		fxp		# Intel EtherExpress PRO/100B (82557, 82558)
+device		pcn		# AMD Am79C97x PCI 10/100 NICs
+device		rl		# RealTek 8129/8139
+device		sf		# Adaptec AIC-6915 (``Starfire'')
+device		sis		# Silicon Integrated Systems SiS 900/SiS 7016
+device		ste		# Sundance ST201 (D-Link DFE-550TX)
+device		tl		# Texas Instruments ThunderLAN
+device		vr		# VIA Rhine, Rhine II
+device		wb		# Winbond W89C840F
+device		wx		# Intel Gigabit Ethernet Card (``Wiseman'')
+device		xl		# 3Com 3c90x (``Boomerang'', ``Cyclone'')
+
+# Pseudo devices - the number indicates how many units to allocated.
+pseudo-device	loop		# Network loopback
+pseudo-device	ether		# Ethernet support
+pseudo-device	sl	1	# Kernel SLIP
+pseudo-device	ppp	1	# Kernel PPP
+pseudo-device	tun		# Packet tunnel.
+pseudo-device	pty		# Pseudo-ttys (telnet etc)
+pseudo-device	md		# Memory "disks"
+pseudo-device	gif		# IPv6 and IPv4 tunneling
+pseudo-device	faith	1	# IPv6-to-IPv4 relaying/(translation)
+
+# The `bpf' pseudo-device enables the Berkeley Packet Filter.
+# Be aware of the administrative consequences of enabling this!
+pseudo-device	bpf		#Berkeley packet filter
+
+# USB support
+# (if you add any USB devices to this list, they must be added to the Alpha
+#  section of src/release/scripts/dokern.sh)
+device		uhci		# UHCI PCI->USB interface
+device		ohci		# OHCI PCI->USB interface
+device		usb		# USB Bus (required)
+device		ugen		# Generic
+device		uhid		# "Human Interface Devices"
+device		ukbd		# Keyboard
+device		ulpt		# Printer
+device		umass		# Disks/Mass storage - Requires scbus and da0
+device		ums		# Mouse
+# USB Ethernet
+device		aue		# ADMtek USB ethernet
+device		cue		# CATC USB ethernet
+device		kue		# Kawasaki LSI USB ethernet
+
+# ALTQ options
+options 	ALTQ		#alternate queueing
+#options 	ALTQ_CBQ	#class based queueing
+#options 	ALTQ_WFQ	#weighted fair queueing
+#options 	ALTQ_FIFOQ	#fifo queueing
+#options 	ALTQ_RED	#random early detection
+#options 	ALTQ_FLOWVALVE	#flowvalve for RED (needs RED)
+#options 	ALTQ_RIO	#triple	 red for diffserv (needs RED)
+#options 	ALTQ_LOCALQ	#local use
+#options 	ALTQ_HFSC	#hierarchical fair service curve
+#options 	ALTQ_ECN	#ecn extention to tcp (needs RED)
+#options 	ALTQ_IPSEC	#check ipsec in IPv4
+#options 	ALTQ_CDNR	#diffserv traffic conditioner
+#options 	ALTQ_BLUE	#blue by wu-chang feng
+#options 	ALTQ_PRIQ	#priority queue
+#options 	ALTQ_NOPCC	#don't use processor cycle counter
+#options 	ALTQ_DEBUG	#for debugging
+# you might want to set kernel timer to 1kHz if you use CBQ,
+# especially with 100baseT
+#options 	HZ=1000
+
+# options added for ALTQ
+options		NMBCLUSTERS=2048
+options		MROUTING		# Multicast routing
+pseudo-device	atm
+device		en
+#options	NATM			#native mode atm
diff -urN ../sys/conf/files ./conf/files
--- ../sys/conf/files	Sat Aug 11 09:54:14 2001
+++ ./conf/files	Tue Oct  2 22:06:19 2001
@@ -40,6 +40,20 @@
 	compile-with	"perl5 $S/kern/makeops.pl -h $S/kern/bus_if.m"	\
 	no-obj no-implicit-rule before-depend				\
 	clean		"bus_if.h"
+altq/altq_afmap.c	optional altq
+altq/altq_blue.c	optional altq
+altq/altq_cbq.c		optional altq
+altq/altq_cdnr.c	optional altq
+altq/altq_conf.c	optional altq
+altq/altq_fifoq.c	optional altq
+altq/altq_hfsc.c	optional altq
+altq/altq_localq.c	optional altq
+altq/altq_priq.c	optional altq
+altq/altq_red.c		optional altq
+altq/altq_rio.c		optional altq
+altq/altq_rmclass.c	optional altq
+altq/altq_subr.c	optional altq
+altq/altq_wfq.c		optional altq
 coda/coda_namecache.c	optional vcoda
 coda/coda_fbsd.c	optional vcoda
 coda/coda_psdev.c	optional vcoda
diff -urN ../sys/conf/options ./conf/options
--- ../sys/conf/options	Fri Aug  3 09:47:27 2001
+++ ./conf/options	Tue Oct  2 22:06:19 2001
@@ -225,6 +225,25 @@
 MAXSSIZ			opt_rlimit.h
 
 # Net stuff.
+# altq stuff
+ALTQ			opt_global.h
+ALTQ_ECN		opt_global.h
+ALTQ_CBQ		opt_altq.h
+ALTQ_WFQ		opt_altq.h
+ALTQ_AFMAP		opt_altq.h
+ALTQ_FIFOQ		opt_altq.h
+ALTQ_RED		opt_altq.h
+ALTQ_FLOWVALVE		opt_altq.h
+ALTQ_RIO		opt_altq.h
+ALTQ_IPSEC		opt_altq.h
+ALTQ_LOCALQ		opt_altq.h
+ALTQ_HFSC		opt_altq.h
+ALTQ_CDNR		opt_altq.h
+ALTQ_BLUE		opt_altq.h
+ALTQ_PRIQ		opt_altq.h
+ALTQ_NOPCC		opt_altq.h
+ALTQ_DEBUG		opt_altq.h
+ 
 ACCEPT_FILTER_DATA
 ACCEPT_FILTER_HTTP
 BOOTP			opt_bootp.h
diff -urN ../sys/dev/ed/if_ed.c ./dev/ed/if_ed.c
--- ../sys/dev/ed/if_ed.c	Thu Jul 26 03:06:00 2001
+++ ./dev/ed/if_ed.c	Tue Oct  2 22:06:19 2001
@@ -1604,9 +1604,10 @@
 		ifp->if_ioctl = ed_ioctl;
 		ifp->if_watchdog = ed_watchdog;
 		ifp->if_init = ed_init;
-		ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+		IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
 		ifp->if_linkmib = &sc->mibdata;
 		ifp->if_linkmiblen = sizeof sc->mibdata;
+		IFQ_SET_READY(&ifp->if_snd);
 		/*
 		 * XXX - should do a better job.
 		 */
@@ -2009,7 +2010,7 @@
 		ifp->if_flags |= IFF_OACTIVE;
 		return;
 	}
-	IF_DEQUEUE(&ifp->if_snd, m);
+	IFQ_DEQUEUE(&ifp->if_snd, m);
 	if (m == 0) {
 
 		/*
